#include "descriptor/descriptor.h"

int main(void) {

  ITEM	glass,ceramic,brown,yellow,blu,white,metal,black,grey;
  ITEM  soffitto, pavimento, base_superiore, filo, base_inferiore;
  ITEM  curva1, curva2, curva3, curva4, curva5;
  ITEM  base_candela1,base_candela2,base_candela3,base_candela4,base_candela5;
  ITEM  candela1,candela2,candela3,candela4,candela5;
  ITEM  campana1,campana2,campana3,campana4,campana5;
  ITEM  spessore_inf_campana1,spessore_inf_campana2,spessore_inf_campana3,spessore_inf_campana4,spessore_inf_campana5;
  ITEM  spessore_sup_campana1,spessore_sup_campana2,spessore_sup_campana3,spessore_sup_campana4,spessore_sup_campana5;
  ITEM  lampadina_inf1,lampadina_inf2,lampadina_inf3,lampadina_inf4,lampadina_inf5;
  ITEM  lampadina_sup1,lampadina_sup2,lampadina_sup3,lampadina_sup4,lampadina_sup5;
  ITEM  asta1_campana1, asta2_campana1,asta1_campana2,asta2_campana2,asta1_campana3,asta2_campana3;
  ITEM  asta1_campana4,asta2_campana4,asta1_campana5,asta2_campana5;
  ITEM  base_tavolo,piede1,piede2,piede3,piede4,vaso;
  ITEM	scene;

  set_background(1.0,1.0,0.8,TRUE);
  set_ambient_light(1,1,1,0.8);
  create_point_light(2.0,2.0,2.0,1,1,1,1.1,20, "light1");
  create_point_light(-2.0,2.0,2.0,1,1,1,0.90,20, "light2");
  create_distant_light(0.0,0.0,1.7,1,1,1,0.90, "light3");

  /*** ATTRIBUTE ceramic ***/
  ceramic = create_attribute("ceramic");
  set_color(ceramic,0.89,0.66,0.55,0.1,0.8);
  set_reflectivity(ceramic,0.2,128);

  /*** ATTRIBUTE brown ***/
  brown = create_attribute("brown");
  set_color(brown,0.73,0.23,0.03,0.2,0.8);
  set_reflectivity(brown,0.17,15);

  /*** ATTRIBUTE yellow ***/
  yellow = create_attribute("yellow");
  set_color(yellow,0.8,0.8,0,0.2,0.8);
  set_reflectivity(yellow,0.3,10);

  /*** ATTRIBUTE blu ***/
  blu = create_attribute("blu");
  set_color(blu,0,0,1,0.5,0.5);
  set_reflectivity(blu,0.3,10);

  /*** ATTRIBUTE white ***/
  white = create_attribute("white");
  set_color(white,0.9,0.9,0.9,0.3,0.7);
  set_reflectivity(white,0.3,10);
 
  /*** ATTRIBUTE black ***/
  black = create_attribute("black");
  set_color(black,0.1,0.1,0.1,0.3,0.7);
  set_reflectivity(black,0.3,10);
  
  /*** ATTRIBUTE glass ***/
  glass = create_attribute("glass");
  set_color(glass,0.68,0.86,1,0.5,0.5);
  set_reflectivity(glass,0.24,2);
  set_transparency(glass,0.87,0.68,1,1.52);

  /*** ATTRIBUTE metal ***/
  metal = create_attribute("metal");
  set_color(metal,0.3,0.23,0.3,0.5,0.5);
  set_reflectivity(metal,0.40,2);
  set_transparency(metal,0.2,0.1,0,2.417);
  
  /*** ATTRIBUTE grey ***/
  grey = create_attribute("grey");
  set_color(grey,0.35,0.35,0.35,0.3,0.7);
  set_reflectivity(grey,0.3,2);
  set_transparency(grey,0.7,0.3,0,2.417);
	  
  
  soffitto = read_nurbs("soffitto.db");
  set_attribute(soffitto,blu);

  pavimento = read_nurbs("pavimento.db");
  set_translate(pavimento,10.0,10.0,10.0);
  set_cube_texture(pavimento,white,blu);
  set_translate(pavimento,-10.0,-10.0,-10.0);

  base_superiore = read_nurbs("base_superiore.db");
  set_attribute(base_superiore,metal);

  filo = read_nurbs("filo.db");
  set_attribute(filo,black);

  base_inferiore = read_nurbs("base_inferiore.db");
  set_attribute(base_inferiore,metal);
  
  curva1 = read_nurbs("curva1.db");
  set_attribute(curva1,metal);
  
  curva2 = read_nurbs("curva2.db");
  set_attribute(curva2,metal);
  
  curva3 = read_nurbs("curva3.db");
  set_attribute(curva3,metal);
  
  curva4 = read_nurbs("curva4.db");
  set_attribute(curva4,metal);
  
  curva5 = read_nurbs("curva5.db");
  set_attribute(curva5,metal);

  base_candela1 = read_nurbs("base_candela1.db");
  set_attribute(base_candela1,grey);
  
  base_candela2 = read_nurbs("base_candela2.db");
  set_attribute(base_candela2,grey);

  base_candela3 = read_nurbs("base_candela3.db");
  set_attribute(base_candela3,grey);

  base_candela4 = read_nurbs("base_candela4.db");
  set_attribute(base_candela4,grey);

  base_candela5 = read_nurbs("base_candela5.db");
  set_attribute(base_candela5,grey);
  
  candela1 = read_nurbs("candela1.db");
  set_attribute(candela1,yellow);

  candela2 = read_nurbs("candela2.db");
  set_attribute(candela2,yellow);

  candela3 = read_nurbs("candela3.db");
  set_attribute(candela3,yellow);

  candela4 = read_nurbs("candela4.db");
  set_attribute(candela4,yellow);

  candela5 = read_nurbs("candela5.db");
  set_attribute(candela5,yellow);

  campana1 = read_nurbs("campana1.db");
  set_attribute(campana1,glass);

  campana2 = read_nurbs("campana2.db");
  set_attribute(campana2,glass);
  
  campana3 = read_nurbs("campana3.db");
  set_attribute(campana3,glass);
  
  campana4 = read_nurbs("campana4.db");
  set_attribute(campana4,glass);
  
  campana5 = read_nurbs("campana5.db");
  set_attribute(campana5,glass);
  
  spessore_sup_campana1= read_nurbs("spessore_sup_campana1.db");
  set_attribute(spessore_sup_campana1,glass);
  
  spessore_sup_campana2= read_nurbs("spessore_sup_campana2.db");
  set_attribute(spessore_sup_campana2,glass);
  
  spessore_sup_campana3 = read_nurbs("spessore_sup_campana3.db");
  set_attribute(spessore_sup_campana3,glass);
  
  spessore_sup_campana4 = read_nurbs("spessore_sup_campana4.db");
  set_attribute(spessore_sup_campana4,glass);
 
  spessore_sup_campana5 = read_nurbs("spessore_sup_campana5.db");
  set_attribute(spessore_sup_campana5,glass);

  spessore_inf_campana1 = read_nurbs ("spessore_inf_campana1.db");
  set_attribute(spessore_inf_campana1,glass);
  
  spessore_inf_campana2 = read_nurbs ("spessore_inf_campana2.db");
  set_attribute(spessore_inf_campana2,glass);
  
  spessore_inf_campana3 = read_nurbs ("spessore_inf_campana3.db");
  set_attribute(spessore_inf_campana3,glass);
  
  spessore_inf_campana4 = read_nurbs ("spessore_inf_campana4.db");
  set_attribute(spessore_inf_campana4,glass);
  
  spessore_inf_campana5 = read_nurbs ("spessore_inf_campana5.db");
  set_attribute(spessore_inf_campana5,glass);
  
  lampadina_inf1 = read_nurbs("lampadina_inf1.db");
  set_attribute (lampadina_inf1,ceramic);

  lampadina_inf2 = read_nurbs("lampadina_inf2.db");
  set_attribute(lampadina_inf2,ceramic);

  lampadina_inf3 = read_nurbs("lampadina_inf3.db");
  set_attribute (lampadina_inf3,ceramic);

  lampadina_inf4 = read_nurbs("lampadina_inf4.db");
  set_attribute(lampadina_inf4,ceramic);

  lampadina_inf5 = read_nurbs("lampadina_inf5.db");
  set_attribute (lampadina_inf5,ceramic);

  lampadina_sup1 = read_nurbs("lampadina_sup1.db");
  set_attribute(lampadina_sup1,glass);

  lampadina_sup2 = read_nurbs("lampadina_sup2.db");
  set_attribute(lampadina_sup2,glass);

  lampadina_sup3 = read_nurbs("lampadina_sup3.db");
  set_attribute(lampadina_sup3,glass);

  lampadina_sup4 = read_nurbs("lampadina_sup4.db");
  set_attribute(lampadina_sup4,glass);

  lampadina_sup5 = read_nurbs("lampadina_sup5.db");
  set_attribute(lampadina_sup5,glass);
  
  base_tavolo = read_nurbs("base_tavolo.db");
  set_attribute(base_tavolo,brown);
  
  piede1 = read_nurbs("piede1.db");
  set_attribute(piede1,brown);
  
  piede2 = read_nurbs("piede2.db");
  set_attribute(piede2,brown);
  
  piede3 = read_nurbs("piede3.db");
  set_attribute(piede3,brown);
  
  piede4 = read_nurbs("piede4.db");
  set_attribute(piede4,brown);
  
  asta1_campana1 = read_nurbs("asta1_campana1.db");
  set_attribute(asta1_campana1,yellow);
  
  asta2_campana1 = read_nurbs("asta2_campana1.db");
  set_attribute(asta2_campana1,yellow);
  
  asta1_campana2 = read_nurbs("asta1_campana2.db");
  set_attribute(asta1_campana2,yellow);
  
  asta2_campana2 = read_nurbs("asta2_campana2.db");
  set_attribute(asta2_campana2,yellow);
  
  asta1_campana3 = read_nurbs("asta1_campana3.db");
  set_attribute(asta1_campana3,yellow);
  
  asta2_campana3 = read_nurbs("asta2_campana3.db");
  set_attribute(asta2_campana3,yellow);
  
  asta1_campana4 = read_nurbs("asta1_campana4.db");
  set_attribute(asta1_campana4,yellow);
  
  asta2_campana4 = read_nurbs("asta2_campana4.db");
  set_attribute(asta2_campana4,yellow);
  
  asta1_campana5 = read_nurbs("asta1_campana5.db");
  set_attribute(asta1_campana5,yellow);
  
  asta2_campana5 = read_nurbs("asta2_campana5.db");
  set_attribute(asta2_campana5,yellow);

  vaso = read_nurbs("vaso.db");
  set_attribute(vaso,glass);
  
  scene = create_list(soffitto, "scene");
  scene = insert_in_list(scene,pavimento);
  scene = insert_in_list(scene,base_superiore);
  scene = insert_in_list(scene,filo);
  scene = insert_in_list(scene,base_inferiore);
  scene = insert_in_list(scene,curva1);
  scene = insert_in_list(scene,curva2);
  scene = insert_in_list(scene,curva3);
  scene = insert_in_list(scene,curva4);
  scene = insert_in_list(scene,curva5);
  scene = insert_in_list(scene,base_candela1);
  scene = insert_in_list(scene,base_candela2);
  scene = insert_in_list(scene,base_candela3);
  scene = insert_in_list(scene,base_candela4);
  scene = insert_in_list(scene,base_candela5);
  scene = insert_in_list(scene,candela1);
  scene = insert_in_list(scene,candela2);
  scene = insert_in_list(scene,candela3);
  scene = insert_in_list(scene,candela4);
  scene = insert_in_list(scene,candela5);
  scene = insert_in_list(scene,campana1);
  scene = insert_in_list(scene,campana2);
  scene = insert_in_list(scene,campana3);
  scene = insert_in_list(scene,campana4);
  scene = insert_in_list(scene,campana5);
  scene = insert_in_list(scene,spessore_sup_campana1);
  scene = insert_in_list(scene,spessore_sup_campana2);
  scene = insert_in_list(scene,spessore_sup_campana3);
  scene = insert_in_list(scene,spessore_sup_campana4);
  scene = insert_in_list(scene,spessore_sup_campana5);
  scene = insert_in_list(scene,spessore_inf_campana1);
  scene = insert_in_list(scene,spessore_inf_campana2);
  scene = insert_in_list(scene,spessore_inf_campana3);
  scene = insert_in_list(scene,spessore_inf_campana4);
  scene = insert_in_list(scene,spessore_inf_campana5);
  scene = insert_in_list(scene,lampadina_inf1);
  scene = insert_in_list(scene,lampadina_inf2);
  scene = insert_in_list(scene,lampadina_inf3);
  scene = insert_in_list(scene,lampadina_inf4);
  scene = insert_in_list(scene,lampadina_inf5);
  scene = insert_in_list(scene,lampadina_sup1);
  scene = insert_in_list(scene,lampadina_sup2);
  scene = insert_in_list(scene,lampadina_sup3);
  scene = insert_in_list(scene,lampadina_sup4);
  scene = insert_in_list(scene,lampadina_sup5);
  scene = insert_in_list(scene,base_tavolo);
  scene = insert_in_list(scene,piede1);
  scene = insert_in_list(scene,piede2);
  scene = insert_in_list(scene,piede3);
  scene = insert_in_list(scene,piede4);
  scene = insert_in_list(scene,asta1_campana1);
  scene = insert_in_list(scene,asta2_campana1);
  scene = insert_in_list(scene,asta1_campana2);
  scene = insert_in_list(scene,asta2_campana2);
  scene = insert_in_list(scene,asta1_campana3);
  scene = insert_in_list(scene,asta2_campana3);
  scene = insert_in_list(scene,asta1_campana4);
  scene = insert_in_list(scene,asta2_campana4);
  scene = insert_in_list(scene,asta1_campana5);
  scene = insert_in_list(scene,asta2_campana5);
  scene = insert_in_list(scene,vaso);
  save_scene("lampadario.md","scene_lampadario",scene);
  return(0);
}
